program BRUN_VIEW;

{$A+,B+,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S+,T-,V+,X+}
{$M 16384,65536,65536}

var
  f       : file;
  Buffer  : pointer;
  readed  : word;
  Palette : array [1..768] of byte;

type
  BRUNFile = record
    Signature : array [1..4] of char;
    Width     : word;
    Height    : word;
    Data      : record end;
  end;

procedure BrunView; assembler;
asm
        mov     ax,0013h
        int     10h
        push    ds
        pop     es
        mov     dx,OFFSET Palette
        mov     cx,256
        xor     bx,bx
        mov     ax,1012h
        int     10h
        push    ds
        lds     si,ds:[Buffer]
        cmp     ds:word ptr [BRUNFile.Signature+0],'RB'
        jne     @@8
        cmp     ds:word ptr [BRUNFile.Signature+2],'NU'
        jne     @@8
        mov     cx,ds:[BRUNFile.Width]
        mov     dx,ds:[BRUNFile.Height]
        or      cx,cx
        jz      @@8
        or      dx,dx
        jz      @@8
        cmp     cx,320
        ja      @@8
        cmp     dx,200
        ja      @@8
        mov     ax,0A000h
        mov     es,ax
        mov     si,OFFSET BRUNFile.Data
        xor     di,di
        xor     cx,cx
  @@1:  push    di
        mov     bl,ds:[si]
        inc     si
        or      bl,bl
        jz      @@3
  @@2:  mov     cl,ds:[si]
        inc     si
        test    cl,80h
        jnz     @@4
        inc     cl
        lodsb
        rep     stosb
        jmp     @@5
  @@4:  neg     cl
        rep     movsb
  @@5:  dec     bl
        jnz     @@2
  @@3:  pop     di
        add     di,320
        dec     dx
        jnz     @@1

        xor     ax,ax
        int     16h
  @@8:  mov     ax,0003h
        int     10h

        pop     ds
end;


begin
  if paramcount<>2 then
   writeln('BRUNVIEW. Use: BRUNVIEW _BRN_file_ _PAL_file_')
  else
   begin
     getmem(Buffer,65535);
     assign(f,paramstr(1));
     reset(f,1);
     blockread(f,Buffer^,65535,readed);
     close(f);

     assign(f,paramstr(2));
     reset(f,1);
     blockread(f,Palette,768);
     close(f);

     BrunView;
   end;
end.